#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct tree {
    vector<ll> a;

    tree(vector<ll> a) : a(a) {
    }

    vector<ll> t;

    void build(ll l, ll r, ll v) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        ll mid = (l + r) / 2;
        build(l, mid, v * 2 + 1);
        build(mid, r, v * 2 + 2);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    ll get(ll l, ll r, ll ql, ll qr, ll v) {
        if (l>=qr || r <= ql)
            return 1e18;
        if (ql <= l && r <= qr)
            return t[v];
        ll mid = (l + r) / 2;
        ll p1 = get(l, mid, ql, qr, 2 * v + 1);
        ll p2 = get(mid, r, ql, qr, 2 * v + 2);
        return min(p1, p2);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n), pref(n + 1);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    tree T(a);
    T.t.resize(4*n);
    T.build(0, n, 0);
    ll maxi = -1;
    ll x = n - k + 1;
    for (ll i = 0; i <= n - x; i++) {
        ll q = T.get(0, n, 0, i, 0), f = T.get(0, n, i + x, n, 0);
        if (pref[i + x] - pref[i] - min(q, f) > maxi) {
            maxi = pref[i + x] - pref[i] - min(q, f);
        }
    }
    cout << maxi;
    return 0;
}
