#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, s;
    cin >> n >> s;
    vector<vector<ll> > a(n);
    vector<ll> pref(n);
    for (ll i = 0; i < n; i++) {
        ll k;
        cin >> k;
        pref[i + 1] = pref[i] + k;
        for (ll j = 0; j < k; j++) {
            ll x;
            cin >> x;
            a[i].push_back(x);
        }
    }
    vector<vector<pair<bool, ll> > > dp(pref[n] + 1, vector<pair<bool, ll> >(s + 1, {0, 0}));
    dp[0][0] = {1, -1};
    ll r = 1;
    set<ll> w;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < a[i].size(); j++) {
            for (ll x = s; x >= 0; x--) {
                if (x - a[i][j] >= 0 && dp[r - 1][x - a[i][j]].first) {
                    dp[r][x] = {1, i};
                } else {
                    dp[r][x] = dp[r - 1][x];
                }
            }
            r++;
        }
    }
    vector<vector<ll> > ans(n);
    ll x = pref[n], y = s;
    bool ok = 1;
    if (dp[x][y].first) {
        while (dp[x][y].second != -1) {
            ll ind = lower_bound(pref.begin(), pref.end(), x) - pref.begin() - 1;
            ll q = dp[x][y].second;
            if (y - a[q][x - pref[ind] - 1] >= 0 && dp[x - 1][y - a[q][x - pref[ind] - 1]].first) {
                ans[q].push_back(x - pref[ind]);
                y -= a[q][x - pref[ind] - 1];
                x--;
            } else if (dp[x - 1][y].first) {
                x--;
            } else {
                ans[q].push_back(x - pref[ind]);
                break;
            }
        }
        for (ll i = 0; i < n; i++) {
            if (ans[i].size() == 0) {
                cout << "No";
                exit(0);
            }
        }
        for (ll i = 0; i < n; i++) {
            cout << ans[i].size() << '\n';
            for (ll j = 0; j < ans[i].size(); j++) {
                cout << ans[i][j] << ' ';
            }
            cout << '\n';
        }
    } else {
        cout << "No";
    }
}
